
-- Base Library for Linux

include "misc.e"
include "file.e"
include "get.e"

-- load opened (integer) or not (string) binary file to string. Use 0 for load to end of file.
global function get_bin(object xx, integer numb)
integer i0, i1, i2
sequence s0
s0={}
if atom(xx) then i0=xx else i0=open(xx,"rb") end if
if i0<0 then return s0 end if
i1=0
while 1 do
	i2=getc(i0)
	if i2<0 then
		close(i0)
		exit
	end if
	if numb>0 and i1>numb then
		if atom(xx)=0 then close(i0) end if
		exit
	end if
	s0=append(s0,i2)
	i1=i1+1
end while
return s0
end function

-- load text from opened (integer) or not (string) file. Define how many lines (0=to end). Return atom if end_of_file and close file.
global function get_txt(object xx, integer how)
integer w, i0, i1
sequence s0, s1
s0={}
s1={}
i0=0
if atom(xx) then w=xx else w=open(xx,"rb") end if
if w<0 then return -1 end if
while 1 do
	i1=getc(w)
	if i1<0 then
		close(w)
		if length(s1)>0 then s0=append(s0,s1) end if
		if i0=0 then return -1 else exit end if
	end if
	if i1=10 then
		s0=append(s0,s1)
		s1={}
		i0=i0+1
		if how>0 and i0=how then
			if atom(xx)=0 then close(w) end if
			exit
		end if
	elsif i1!=13 then
		s1=append(s1,i1)
	end if
end while
if how=1 then return s0[1] end if
return s0
end function

-- return file size or -1 if not exist
global function file_size(object fle)
integer i0, i1
i1=0
if atom(fle) then i0=fle else i0=open(fle,"rb") end if
if i0<0 then return i0 end if
while getc(i0)>=0 do
	i1=i1+1
end while
if atom(fle)=0 then close(i0) end if
return i1
end function

--puts list of strings to opened file or screen (1) (integer) or not (string)
global procedure put_txt(object w, sequence txt)
integer i0
sequence crlf
if atom(w) then i0=w else i0=open(w,"w") end if
if length(txt)=0 or i0<0 then return end if
if platform()=3 then crlf="\n" else crlf="\r\n" end if
if atom(txt[1]) then
	puts(i0,txt & crlf)
else
	for i01=1 to length(txt) do
		puts(i0,txt[i01] & crlf)
	end for
end if
if atom(w)=0 then close(i0) end if
end procedure

-- string replace:  s = replace(s1, s2, s3)
-- replace all occurences of s2 with s3 in s1
global function replace(sequence s_main, sequence s_what, sequence s_with)
sequence s0
integer i0
s0=s_main
while 1 do
    i0=match(s_what,s0)
    if i0=0 then
        exit
    end if
    if i0=1 then
        s0=s_with+s0[length(s_what)+1..length(s0)]
    else
        s0=s0[1..i0-1] & s_with & s0[i0+length(s_what)..length(s0)]
    end if
end while
return s0
end function

-- copy file
global procedure file_copy(sequence src, sequence dest)
system("cp \"" & src & "\" \"" & dest & "\" > /dev/null",2)
end procedure

-- move file
global procedure file_move(sequence src, sequence dest)
system("mv \"" & src & "\" \"" & dest & "\" > /dev/null",2)
end procedure

-- remove files/directoryes (use wilcard '*' and all=1 for all)
global procedure file_remove(sequence src, integer all)
if all=0 then
	system("rm \"" & src & "\" > /dev/null",2)
else
	system("rm -r \"" & src & "\" > /dev/null",2)
end if
end procedure

-- trim character of string from booth side
global function trim(sequence st, integer ch)
sequence s0
if length(st)=0 then return st end if
for i0=1 to length(st) do
	if st[i0]!=ch then
		s0=st[i0..length(st)]
		exit
	end if
end for
for i0=length(s0) to 1 by -1 do
	if s0[i0]!=ch then
		s0=s0[1..i0]
		exit
	end if
end for
return s0
end function

-- get left part of string/sequence. If out of bound, return empty sequence
global function left(sequence st, integer how)
if how>0 and how<=length(st) then
	if how=1 then return {st[1]} else return st[1..how] end if
end if
return {}
end function

-- get right part of string/sequence. If out of bound, return empty sequence
global function right(sequence st, integer how)
if how>0 and how<=length(st) then
	if how=1 then return {st[length(st)]} else return st[length(st)-how+1..length(st)] end if
end if
return {}
end function

-- extended system(). Can use 4 for run hide. Use wt=0 for run without wait to end.
global procedure system_ex(sequence st, integer how, integer wt)
if length(st)=0 then return end if
if how<=0 or how<=3 then
	if wt=0 then system("(" & st & " &)",how) else system(st,how) end if
elsif how=4 then
	if wt=0 then system("(" & st & " &) > /dev/null",2) else system(st & " > /dev/null",2) end if
end if
end procedure

-- run console command and return result in text lines sequence
global function get_run_console(sequence cmd)
sequence s0
system(cmd & " > /tmp/run_console.tmp",2)
s0=get_txt("/tmp/run_console.tmp",0)
system("rm /tmp/run_console.tmp > /dev/null",2)
if length(s0)=1 then s0=s0[1] end if
return s0
end function

-- return list of files (pathes only) in folder and all subfolders.
-- "" -> current folder paths (same as "*")  "*.*" -> current folder files only  "/path/" -> defined folder pathes
-- "/path/*.avi" -> defined folder files only with defined extension
global function dir_files(sequence dr)
sequence s0
integer i0
i0=0
if length(dr)<3 then
	s0="\"" & current_dir() & "\""
elsif dr[1]!='/' then
	s0="\"" & current_dir() & "\" -name \"" & dr & "\""
	i0=1
elsif dr[length(dr)]='/' then
	s0="\"" & dr[1..length(dr)-1] & "\""
else
	for i01=length(dr) to 1 by -1 do
		if dr[i01]='/' then
			if i01>1 then
				s0="\"" & dr[1..i01-1] & "\" -name \"" & dr[i01+1..length(dr)] & "\""
				i0=1
			else
				s0="\"" & current_dir() & "\" -name \"" & dr[i01+1..length(dr)] & "\""
			end if
			exit
		end if
	end for
end if
system("find " & s0 & " > /tmp/dir_files.tmp",2)
s0=get_txt("/tmp/dir_files.tmp",0)
if i0=0 or length(s0)=0 then return s0 end if
for i01=1 to length(s0) do
	for i02=length(s0[i01]) to 1 by -1 do
		if s0[i01][i02]='/' then
			s0[i01]=s0[i01][i02+1..length(s0[i01])]
			exit
		end if
	end for
end for
return s0
end function

-- return list of all strings between s_st to s_en from string st
global function all_matches(sequence st, sequence s_st, sequence s_en)
integer i0, i1
sequence s0
if length(st)=0 or length(s_st)=0 or length(s_en)=0 then return {} end if
s0={}
i0=1
while 1 do
	i0=match_from(s_st,st,i0)
	if i0=0 then exit end if
	i1=match_from(s_en,st,i0)
	if i1=0 then exit end if
	s0=append(s0,st[i0..i1-1])
	i0=i1
end while
return s0
end function

-- delimite string to words:  s = delimite(string, delimiter)
global function delimite(sequence st, integer dlm)
sequence s0, s1
s0={}
s1={}
if dlm<0 then dlm=32 end if
if find(dlm,st)=0 then return {} end if
for i01=1 to length(st) do
	if st[i01]=dlm then
		s0=append(s0,s1)
		s1={}
	else
		s1=s1 & st[i01]
	end if
end for
if length(s1)>0 then s0=append(s0,s1) end if
return s0
end function
